"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var custom_validators_service_1 = require("../../shared/service/custom-validators.service");
var BaseFilterComponent = /** @class */ (function () {
    function BaseFilterComponent() {
        this.onSearch = new core_1.EventEmitter();
        this.onReset = new core_1.EventEmitter();
    }
    BaseFilterComponent.prototype.submit = function (value) {
        if (!this.myForm.valid) {
            //this.myForm.dirty puede que no lo hayamos tocado
            var errores = custom_validators_service_1.CustomValidators.validateForm(this.myForm);
            alert("El filtre de cerca cont\u00E9 les seg\u00FCents errades: " + errores.reduce(function (v1, v2) { return v1 + '\n' + v2; }, ''));
        }
        else {
            this.filter.pagina = 1; //cada vez que ejecutamos una búsqueda empezamos en la página 1
            this.onSearch.emit(this.filter); //comunicamos hacia arriba que debe realizarse la búsqueda
        }
    };
    BaseFilterComponent.prototype.resetFilter = function () {
        this.filter.reset();
        this.onReset.emit(this.filter);
        this.postResetFilter();
        return false;
    };
    BaseFilterComponent.prototype.postResetFilter = function () {
        this.filterOrders && this.filterOrders[0] && this.changeOrder(this.filterOrders[0]);
    };
    BaseFilterComponent.prototype.changeOrder = function (newOrder) {
        if (this.filterOrders) {
            this.filter.columnasOrdenacion = this.filterOrders.find(function (o) { return o.value === newOrder.value; }).order;
            this.currentOrder = newOrder.value;
        }
    };
    Object.defineProperty(BaseFilterComponent.prototype, "diagnostic", {
        get: function () { return JSON.stringify(this.filter); },
        enumerable: true,
        configurable: true
    });
    BaseFilterComponent.propDecorators = {
        "displayFilter": [{ type: core_1.Input },],
        "onSearch": [{ type: core_1.Output },],
        "onReset": [{ type: core_1.Output },],
    };
    return BaseFilterComponent;
}());
exports.BaseFilterComponent = BaseFilterComponent;
var FilterOrder = /** @class */ (function () {
    function FilterOrder(value, label, order) {
        this.value = value;
        this.label = label;
        this.order = order;
    }
    return FilterOrder;
}());
exports.FilterOrder = FilterOrder;
//# sourceMappingURL=base-filter.component.js.map